searchNodes=[{"ref":"Archivist.html","title":"Archivist","type":"module","doc":""},{"ref":"Archivist.Archive.html","title":"Archivist.Archive","type":"module","doc":"Module that coordinates the structured parsing and return of assets in the articles root directory. Precompiles and provides interface to interact with your articles. By most Elixir and Erlang conventions this module should be called &#39;Archivist.Repo&#39; since it&#39;s being used for data access, but this library is called Archivist so we&#39;re calling it an Archive. Deal with it. defmodule MyApp.Archive do use Archivist.Archive, root: &quot;some/other/dir&quot;, body_parser: Earmark end alias MyApp.Archive {:ok, articles} = Archive.all() {:ok, authors} = Archive.authors() {:ok, image_paths} = Archive.image_paths() {:ok, tags} = Archive.tags() {:ok, topics} = Archive.topics() {:ok, titles} = Archive.titles() {:ok, slugs} = Archive.slugs() {:ok, created_asc} = Archive.sort_by :created_at, :asc {:ok, published_desc} = Archive.sort_by :published_at, :desc {:ok, article} = Archive.fetch_by :slug, &quot;some-article&quot;"},{"ref":"Archivist.Article.html","title":"Archivist.Article","type":"module","doc":"The core datatype for Archivist. Articles are broken into header and body/content parts then compiled into the %Archivist.Article{} struct."},{"ref":"Archivist.Article.html#t:t/0","title":"Archivist.Article.t/0","type":"type","doc":""},{"ref":"Archivist.ArticleParser.html","title":"Archivist.ArticleParser","type":"module","doc":""},{"ref":"Archivist.ArticleParser.html#build_paths/4","title":"Archivist.ArticleParser.build_paths/4","type":"function","doc":""},{"ref":"Archivist.ArticleParser.html#convert_structs/2","title":"Archivist.ArticleParser.convert_structs/2","type":"function","doc":""},{"ref":"Archivist.ArticleParser.html#filter_valid/1","title":"Archivist.ArticleParser.filter_valid/1","type":"function","doc":""},{"ref":"Archivist.ArticleParser.html#parse_attr/2","title":"Archivist.ArticleParser.parse_attr/2","type":"function","doc":""},{"ref":"Archivist.ArticleParser.html#parse_attrs/2","title":"Archivist.ArticleParser.parse_attrs/2","type":"function","doc":""},{"ref":"Archivist.ArticleParser.html#parse_files/2","title":"Archivist.ArticleParser.parse_files/2","type":"function","doc":""},{"ref":"Archivist.ArticleParser.html#parse_tags/2","title":"Archivist.ArticleParser.parse_tags/2","type":"function","doc":""},{"ref":"Archivist.ArticleParser.html#parse_topics/1","title":"Archivist.ArticleParser.parse_topics/1","type":"function","doc":""},{"ref":"Archivist.ArticleParser.html#parse_topics_list/2","title":"Archivist.ArticleParser.parse_topics_list/2","type":"function","doc":""},{"ref":"Archivist.MapUtils.html","title":"Archivist.MapUtils","type":"module","doc":""},{"ref":"Archivist.MapUtils.html#deep_merge/2","title":"Archivist.MapUtils.deep_merge/2","type":"function","doc":""},{"ref":"readme.html","title":"Archivist","type":"extras","doc":"Archivist Archivist is a straightforward blogging utility for generating article content at compile time from version-controlled article and image files. It is built to be used in conjunction with the Arcdown plaintext article parser library. Archivist is inspired by the general approach of Cẩm Huỳnh&#39;s great Nabo library with some key differences: Archivist articles are formatted in Arcdown format by default, allowing for more robust articles and article features. Archivist allows articles to be organized into nested topic directories for better organization. Topic directory and sub-directory naming will be translated into a hierarchical system-wide topic and sub-topic structure. Archivist supports the use of an &quot;intermediate library pattern&quot;, where content and articles are stored in a dedicated library and seperate repository in order to reduce content-related git clutter in your primary application repo. Archivist currently doesn&#39;t parse article content as markdown, but will add optional content parsing in future versions (like 0.3.x). Archivist adds default attributes for author names and email addresses, as well as sorting content by author. Archivist exposes its article sorting mechanism as an anonymous function, allowing you to implement custom article-sorting strategies at compile-time. Archivist allows you to set a created_at and published_at timestamps to give you greater control over content and how it&#39;s used. Archivist allows you to tag your articles however you&#39;d like, and provides functions for sorting and collecting all tags used across your archive. Archivist generates lists of tags, topics, and authors at compile-time, giving you more flexibility in your content&#39;s front-end presentation without having to perform additional parsing at runtime. Archivist allows you to set constrained lists of valid_topics and valid_tags, and will throw warnings during compilation if tags and topics are used that do not appear in those lists. Archivist allows you to store image files and parse and reference the paths to those files within your archive at archive/images"},{"ref":"readme.html#installation","title":"Archivist - Installation","type":"extras","doc":"The package can be installed by adding archivist to your list of dependencies in mix.exs: def deps do [ {:archivist, &quot;~&gt; 0.2&quot;} ] end"},{"ref":"readme.html#usage","title":"Archivist - Usage","type":"extras","doc":"The heart of Archivist is the Archive module, which acts as a repository for exposing query functions for articles, slugs, topics, etc. You can create an Archive out of any Elixir module by using Archivist.Archive like this: defmodule MyApp.Archive use Archivist.Archive end # the alias is just a nicety here and isn&#39;t required by any means alias MyApp.Archive Archive.articles() Archive.topics() # hierarchical topics Archive.topics_list() # flattened topics and sub-topics Archive.tags() Archive.slugs() Archive.authors() Additionally Archvist exposes helpers for reading paths for articles and image files: Archive.article_paths() Archive.image_paths() Archivist 0.2.x versions expect you to create your article content directory at priv/archive/articles at the root of your elixir library, like this: priv/archive/articles/journey_to_the_center_of_the_earth.ad If you&#39;d like to customize any of your archive&#39;s behavior, you can define any of the following options when it is used in the target archive directory. The values shown are the defaults: defmodule MyApp.Archive use Archivist.Archive archive_dir: &quot;priv/archive&quot;, content_dir: &quot;articles&quot;, content_pattern: &quot;**/*.ad&quot;, image_dir: &quot;images&quot;, image_pattern: &quot;**/*.{jpg,gif,png}&quot;, article_sorter: &amp;(Map.get(&amp;1, :published_at) &gt;= Map.get(&amp;2, :published_at)), application: nil, valid_tags: nil, valid_topics: nil end Archivist will read any files with the .ad extension in your content directory or in any of its subdirectories, and parse the content of those files with the parser you&#39;ve selected (Arcdown by default) If you&#39;d like to store your archive somewhere besides priv/archive you can assign a custom path to your archive like this: defmodule MyApp.Archive use Archivist.Archive, archive_dir: &quot;assets/archive&quot;, end"},{"ref":"readme.html#arcdown","title":"Archivist - Arcdown","type":"extras","doc":"Arcdown supports the following features for articles: Article Content Article Summary Topics Sub-Topics Tags Published Datetime Creation Datetime Author Name Author Email Article Slug Here is an example article written in Arcdown (.ad) format: The Day the Earth Stood Still &lt;the-day-the-earth-stood-still&gt; by Julian Blaustein &lt;julian@blaustein.com&gt; Filed under: Films &gt; Sci-Fi &gt; Classic Created @ 10:24pm on 1/20/2019 Published @ 10:20pm on 1/20/2019 * Sci-Fi * Horror * Thrillers * Aliens Summary: A sci-fi classic about a flying saucer landing in Washington, D.C. --- The Day the Earth Stood Still (a.k.a. Farewell to the Master and Journey to the World) is a 1951 American black-and-white science fiction film from 20th Century Fox, produced by Julian Blaustein and directed by Robert Wise. 0.2.x and 0.1.x versions of Archivist will parse and return article content as Archivist.Article structs. The parsing output of the above article example would look like this: %Archivist.Article{ author: &quot;Julian Blaustein&quot;, content: &quot;The Day the Earth Stood Still (a.k.a. Farewell to the Master and Journey to the\\nWorld) is a 1951 American black-and-white science fiction film from 20th Century\\nFox, produced by Julian Blaustein and directed by Robert Wise.\\n&quot;, created_at: #DateTime&lt;2019-01-20 22:24:00Z&gt;, email: &quot;julian@blaustein.com&quot;, published_at: #DateTime&lt;2019-04-02 04:30:00Z&gt;, slug: &quot;the-day-the-earth-stood-still&quot;, summary: &quot;A sci-fi classic about a flying saucer landing in Washington, D.C.&quot;, tags: [:sci_fi, :horror, :thrillers, :aliens], title: &quot;The Day the Earth Stood Still&quot;, topics: [&quot;Films&quot;, &quot;Sci-Fi&quot;, &quot;Classic&quot;] }"},{"ref":"readme.html#intermediate-library-pattern","title":"Archivist - Intermediate Library Pattern","type":"extras","doc":"While it&#39;s completely acceptable use Archivist.Archive within the same application in which the content archive is located, sites with lots of content and publishers who commit changes frequently will quickly find the git history for their application littered with content-related commits that have nothing to do with the broader functionality of the application itself. To remedy this issue, Archivist permits and encourages the use of an intermediate library to house the content archive (myapp_blog for example), and then to include that intermediate library in the target application where the content is being used and displayed. This approach requires you generate a new mix library with mix new myapp_blog, and then to publish that repository so that it&#39;s available to other Elixir and Erlang applications, via hex.pm or hex.pm organizations for example. The preferred way to implement this approach is to include archivist as a dependency in your intermediate library (rather than in your application), and then to create a new Archive in your intermediate library like this: defmodule MyappBlog.Archive do use Archivist.Archive, application: :myapp_blog, archive_dir: &quot;archive&quot; end Note that this approach requires you to add the name of your otp application in the application flag when your archive is defined. Also note that archive_dir is compressed to just archive instead of priv/archive since this approach automatically assumes that content will be stored in the priv directory of the otp app indicated by the application option. Here is an example of an excerpt from the mixfile of an intermediate library: defp deps do [ {:archivist, &quot;~&gt; 0.2&quot;}, {:ex_doc, &quot;&gt;= 0.0.0&quot;, only: :dev, runtime: false} ] end defp package do [ files: [&quot;lib&quot;, &quot;priv&quot;, &quot;mix.exs&quot;, &quot;README.md&quot;], organization: &quot;my_hex_org&quot; ] end Requiring the priv dir here is essential to ensuring that the content archive is packaged with the hex release, and is then made available for the target application. Setting the organization here scopes the published package to a hex organization, thus ensuring that it remains private. Then in the application where your content is being used, be sure to include the intermediate library as a dependency: defp deps do [ ... {:myapp_blog, &quot;~&gt; 0.1&quot;, organization: &quot;my_hex_org&quot;} ] end And then you should be able to use your content directly in your application: MyappBlog.Archive.articles() MyappBlog.Archive.topics()"},{"ref":"readme.html#topics-and-tags-constraints","title":"Archivist - Topics and Tags Constraints","type":"extras","doc":"As of Archivist version 0.2.6 archives can receive flags for lists of valid_topics and valid_tags like this: defmodule Myapp.Archive do use Archivist, valid_topics: [ &quot;Action&quot;, &quot;Classic&quot;, &quot;Crime&quot;, &quot;Fiction&quot;, &quot;Films&quot;, &quot;Sci-Fi&quot; ], valid_tags: [ :action, :adventure, :aliens, :crime, :horror, :literature, :modern_classic, :sci_fi, :thrillers ] end Adding articles with tags or topics that don&#39;t conform to these lists, or using a topic directory structure that doesn&#39;t conform to these lists will throw warnings at compile time, like this: warning: Archivist Archive contains invalid topics: Action, Classic (archivist) lib/archivist/parsers/article_parser.ex:77: Archivist.ArticleParser.warn_invalid/3 warning: Archivist Archive contains invalid tags: action, adventure (archivist) lib/archivist/parsers/article_parser.ex:77: Archivist.ArticleParser.warn_invalid/3 Compilation will not cease, however, simply because these constraints are being violated. Please note that only exact topic matches are accounted for here, so&quot;Sci-Fi&quot; will not be considered equivalent to &quot;SciFi&quot; and will throw a warning. If you do not want warnings for tags or topics during compilation simply don&#39;t declare any values for valid_topics or valid_tags and they&#39;ll be ignored. Also note that enforcement of valid topics currently is only compared to the flattened list of topics and sub-topics. There is no functionality in place at the moment for constraining specific topic hierarchies."},{"ref":"readme.html#mounting-images-with-plug","title":"Archivist - Mounting Images with Plug","type":"extras","doc":"If you choose to store images with your archive, it&#39;s probably most useful to have that content mounted as a static assets path somewhere where the content can be digested with Webpack or whichever assets manager you&#39;re using. For systems built with Plug (including Phoenix), it&#39;s easy enough to mount the images path with Plug.Static at the path of your choice. Simply call the name of the otp app where your content is stored along with the path to the images: plug Plug.Static, at: &quot;/blog/images/&quot;, from: {:myapp_blog, &quot;priv/archive/images&quot;} Note that for applications that employed the Intermediate Library Pattern, the flags for Plug.Static will look like the example above. For instances where Archivist is being used directly in the target application, the name of the current application should be used here, like this: plug Plug.Static, at: &quot;/blog/images/&quot;, from: {:myapp, &quot;priv/archive/images&quot;} For use within Phoenix in particular, your plug declaration would likely go in the MyappWeb.Endpoint module, like this: defmodule MyappWeb.Endpoint do use Phoenix.Endpoint, otp_app: :myapp # app name here will be :myapp or :myapp_blog depending on which otp app # contains the content archive plug Plug.Static, at: &quot;/blog/images/&quot;, from: {:myapp_blog, &quot;priv/archive/images&quot;}"},{"ref":"readme.html#development-notes","title":"Archivist - Development Notes","type":"extras","doc":"A quick review of the Archivist.Archive implementation would reveal additional options that aren&#39;t otherwise mentioned in this README: defmodule MyApp.Archive use Archivist.Archive content_parser: Earmark, article_parser: Arcdown end These options are currently placeholders for future functionality but do not serve any purpose to the user for the time being. Some notes on forthcoming features: While Earmark is included with Archivist, functionality for parsing content as Earmark has not yet been added. Future versions (like 0.3.x) will add something like a parsed_content attribute to the parsed articles flag, which will contain content parsed as Earmark. Setting this value to nil will cause the article parser not to parse the content at compile-time. Also note that that swapping out the content and article parsers with different modules currently is not supported. ContentParser and ArticleParser behaviors will be implemented in future versions (likely 0.3.x) and will support implementing custom parsers for these elements. Please find additional information about known issues and planned features for Archivist in the issues tracker."},{"ref":"readme.html#todo","title":"Archivist - Todo","type":"extras","doc":"Issues and Todo enhancements are managed at the official Archivist issues tracker on GitHub."},{"ref":"readme.html#availability","title":"Archivist - Availability","type":"extras","doc":"Source code is available at the official Archivist repository on the FunctionHaus GitHub Organization"},{"ref":"readme.html#license","title":"Archivist - License","type":"extras","doc":"Archivist source code is released under Apache 2 License. Check LICENSE file for more information. &copy; 2017 FunctionHaus, LLC"}]